// 
// File:          TauPerformance_MasterMind_Impl.cc
// Symbol:        TauPerformance.MasterMind-v1.4.0
// Symbol Type:   class
// Babel Version: 0.9.8
// sidl Created:  20050124 10:47:17 PST
// Generated:     20050124 10:47:21 PST
// Description:   Server-side implementation for TauPerformance.MasterMind
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.9.8
// source-line   = 31
// source-url    = file:/home/amorris/performance/sidl/components/MasterMind/../TauPerformance.sidl
// 
#include "TauPerformance_MasterMind_Impl.hh"

// DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind._includes)
#include <iomanip>
// DO-NOT-DELETE splicer.end(TauPerformance.MasterMind._includes)

// user defined constructor
void TauPerformance::MasterMind_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind._ctor)
  init_mport=false;
  init_tree = false;
  frameworkServices = 0;
  measurement_m=0;
  call_path_tree = 0;
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind._ctor)
}

// user defined destructor
void TauPerformance::MasterMind_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind._dtor)

  // no reason to put anything here, it won't get called

  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Shuts down a component presence in the calling framework.
 * @param Svc the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * This function is called exactly once for each callback registered
 * through Services.
 * 
 * The argument Svc will never be nil/null.
 * The argument Svc will always be the same as that received in
 * setServices.
 * 
 * During this call the component should release any interfaces
 * acquired by getPort().
 * 
 * During this call the component should reset to nil any stored
 * reference to Svc.
 * 
 * After this call, the component instance will be removed from the
 * framework. If the component instance was created by the
 * framework, it will be destroyed, not recycled, The behavior of
 * any port references obtained from this component instance and
 * stored elsewhere becomes undefined.
 * 
 * Notes for the component implementor:
 * 1) The component writer may perform blocking activities
 * within releaseServices, such as waiting for remote computations
 * to shutdown.
 * 2) It is good practice during releaseServices for the component
 * writer to remove or unregister all the ports it defined.
 */
void
TauPerformance::MasterMind_impl::releaseServices (
  /*in*/ ::gov::cca::Services Svc ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.releaseServices)
  //std::cout<<"\n--------------- MasterMind releaseServices\n\n";

  frameworkServices.releasePort("MeasurementPort");

  Svc.removeProvidesPort("MonitorPort");
  Svc.removeProvidesPort("PerfParamPort");

  Svc.unregisterUsesPort ("MeasurementPort");


  std::cout<<"Shutting down MasterMind\n";
  //delete records
  if (records.size() > 0) {
    int rank = (*records.begin()->second).getRank();
    map<string,Record*>::iterator r;
    r=records.begin();
    //delete each record, also generate an entry in the 
    //database file for each record


    char *dirname;
    if ((dirname = getenv("PROFILEDIR")) == NULL) {
      // Use default directory name .
      dirname  = new char[8];
      strcpy (dirname,".");
    }


    char fname[256];
    string dbfilename = "dbfile";
    sprintf(fname, "%s/%s.%d", dirname, dbfilename.c_str(), rank);
    ofstream outfile(fname, std::ios::app);


    outfile.setf(ios::left);
    
    outfile << "# " << setw(15) << "ComponentName" << " " << setw(32) << "Filename" << endl;
    
    while (r!=records.end()) {
      if (r->second) {
	//get component_name
	std::string c_name = (r->first).substr(0,(r->first).find("::"));
	//outfile<<r->first<<"\t"<<(r->second)->getFileName()<<endl;

	outfile.setf(ios::left);
	
	outfile << "  " << setw(15) << c_name << " " << setw(32) << (r->second)->getFileName() << std::endl;

	outfile.unsetf(ios::left);

	delete r->second;
      }
      r++;
    }
    outfile.close();
    records.clear();
    //delete call path tree
    string fn = "call_path_tree";
    char ctname[256];
    sprintf(ctname, "%s/%s.%d",dirname, fn.c_str(), rank);
    call_path_tree->dumpChildren((string) ctname);
    if (call_path_tree)
      delete call_path_tree;
  }


  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.releaseServices)
}

/**
 * Method:  getPerformanceData[]
 */
int32_t
TauPerformance::MasterMind_impl::getPerformanceData (
  /*in*/ const ::std::string& rname,
  /*out*/ ::sidl::array<double>& data,
  /*in*/ bool reset ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.getPerformanceData)

  //Does the component name we are given exist?
  if (records.find(rname) == records.end()) {
    std::cerr<<"Unable to find component record for : '"<<rname<<"'"<<std::endl;
    return -1;
  }

  std::vector<std::vector<double> > recData;

  Record* rec = records.find(rname)->second;
  rec->getParameters(recData);

  // now convert to a SIDL array
  int32_t size1 = recData.size();

  int32_t size2 = 0;

  // we assume that the vectors of arguments are of the same length
  // this is a reasonable assumption because the number of arguments to a
  // port function are not going to change while the program is running
  if (size1 > 0)
    size2 = recData[1].size();


  int32_t dim = 2;
  int32_t lower[2] = {0,0};
  int32_t upper[2] = {size1,size2};

  data = sidl::array<double>::createRow(dim, lower, upper);

  for (int i = 0; i < size1; i++) {
    for (int j = 0; j < size2; j++) {
      data.set(i,j,recData[i][j]);
    }
  }


  //do we reset the parameters?
  if (reset) {
    rec->resetParameters();
  }
  return 1;

  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.getPerformanceData)
}

/**
 * Method:  getCompMethNames[]
 */
int32_t
TauPerformance::MasterMind_impl::getCompMethNames (
  /*out*/ ::sidl::array< ::std::string>& cm_names ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.getCompMethNames)


  cm_names = ::sidl::array< ::std::string>::create1d(records.size());

  std::map<std::string, Record*>::iterator it;
  int i;
  for (i=0, it = records.begin(); it != records.end(); it++, i++) {
    //cm_names.push_back(it->first);
    cm_names.set(i, it->first);
  }
  return 1;

  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.getCompMethNames)
}

/**
 * Starts up a component presence in the calling framework.
 * @param Svc the component instance's handle on the framework world.
 * Contracts concerning Svc and setServices:
 * 
 * The component interaction with the CCA framework
 * and Ports begins on the call to setServices by the framework.
 * 
 * This function is called exactly once for each instance created
 * by the framework.
 * 
 * The argument Svc will never be nil/null.
 * 
 * Those uses ports which are automatically connected by the framework
 * (so-called service-ports) may be obtained via getPort during
 * setServices.
 */
void
TauPerformance::MasterMind_impl::setServices (
  /*in*/ ::gov::cca::Services services ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.setServices)

  //  std::cout<<"\n--------------- MasterMind setServices\n\n";

  fprintf (stderr, "%s:%d: TauPerformance.MasterMind setServices called\n",
	   __FILE__, __LINE__);

  frameworkServices = services;

  if (frameworkServices._not_nil ()) {
    gov::cca::TypeMap tm = frameworkServices.createTypeMap ();
    if (tm._is_nil ()) {
      fprintf (stderr, "%s:%d: gov::cca::TypeMap is nil\n",
	       __FILE__, __LINE__);
    }

    gov::cca::Port p = self;     //Babel required cast

    if (p._is_nil ()) {
      fprintf (stderr, "p is nil\n");
    }

    frameworkServices.addProvidesPort (p,
				       "MonitorPort",
				       "TauPerformance.Monitor", tm);

    frameworkServices.addProvidesPort (p,
				       "PerfParamPort",
				       "TauPerformance.PerfParam", tm);

    frameworkServices.registerUsesPort ("MeasurementPort", 
					"TauPerformance.Measurement",tm);


    //    frameworkServices.registerUsesPort ("MPIBorrow", 
    //					"ccaffeine.ports.MPIBorrow",tm);
      

    gov::cca::ComponentRelease cr = self;  //  Babel required casting
    frameworkServices.registerForRelease(cr);


  }
  else {
    fprintf (stderr, "%s:%d: TauPerformance.MasterMind service is nil\n",
	     __FILE__, __LINE__);
  }

  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.setServices)
}

/**
 * Method:  startMonitoring[]
 */
void
TauPerformance::MasterMind_impl::startMonitoring (
  /*in*/ const ::std::string& rname ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.startMonitoring)

  //if no record with that name exists, create it.  

  if (records.find(rname) == records.end()) {
    createRecord(rname);
  }

  //first check to see if we have initialized the call path tree
  //if we haven't, do so, otherwise, we need to advance
  string node_name = rname.substr(0,rname.find("::"));

  if (!init_tree) {
    call_path_tree = new CallPathNode(node_name);
    init_tree = true;
  } else{
    call_path_tree = call_path_tree->getChild(node_name);
  }

  //(*records[rname]).setParameters(m);
  (*records[rname]).startTiming(true);
  
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.startMonitoring)
}

/**
 * Method:  stopMonitoring[]
 */
void
TauPerformance::MasterMind_impl::stopMonitoring (
  /*in*/ const ::std::string& rname,
  /*in*/ ::sidl::array< ::std::string> paramNames,
  /*in*/ ::sidl::array<double> paramValues ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.stopMonitoring)

  map<string,double> params;

  for (int i = paramNames.lower(0); i < paramNames.upper(0)+1; i++) {
    params.insert(make_pair(paramNames.get(i),paramValues.get(i)));
  }

  map<string,double> counters;
  (*records[rname]).stopTiming(true, counters, params);
  //when we stop monitoring, assume that compute in component is over, so 
  //we can move back "up" the call-path tree (first, increment the performance 
  //counters for the current node)
  call_path_tree->incrementCounters(counters);
  //before moving back up tree, make sure we have a valid pointer for the root
  //if we don't assume we are at the root.
  if (call_path_tree->getParent())
    call_path_tree = call_path_tree->getParent();

  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.stopMonitoring)
}

/**
 * Method:  setFileName[]
 */
void
TauPerformance::MasterMind_impl::setFileName (
  /*in*/ const ::std::string& rname,
  /*in*/ const ::std::string& fname ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.setFileName)
  (*records[rname]).setFileName(fname);
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.setFileName)
}

/**
 * Method:  dumpData[]
 */
void
TauPerformance::MasterMind_impl::dumpData (
  /*in*/ const ::std::string& rname ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.dumpData)
  (*records[rname]).dumpToFile(rname);
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.dumpData)
}

/**
 * Method:  dumpDataFileName[]
 */
void
TauPerformance::MasterMind_impl::dumpDataFileName (
  /*in*/ const ::std::string& rname,
  /*in*/ const ::std::string& fname ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.dumpDataFileName)
  (*records[rname]).setFileName(fname);
  (*records[rname]).dumpToFile(rname);
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.dumpDataFileName)
}

/**
 * Method:  destroyRecord[]
 */
void
TauPerformance::MasterMind_impl::destroyRecord (
  /*in*/ const ::std::string& rname ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind.destroyRecord)
  map<string,  Record *>::iterator it;
  it=records.find(rname);
  delete it->second;
  records.erase(it);    
  // DO-NOT-DELETE splicer.end(TauPerformance.MasterMind.destroyRecord)
}


// DO-NOT-DELETE splicer.begin(TauPerformance.MasterMind._misc)

void
TauPerformance::MasterMind_impl::createRecord(string rname) {

  //first check to see if we have gotten a measurement port and MPIBorrow port
  //Only do once!!
  if (!init_mport) {
    //Get Measurement port

    gov::cca::Port port;

    port = frameworkServices.getPort("MeasurementPort");
    if (port._not_nil())
      measurement_m = port;
    else {
      std::cerr << "Measurement port not connected!" << std::endl;
      return;
    }
    init_mport=true;
  }//if
  
  //if no record with that name exists, create it.  Otherwise, do nothing.
  if (records.find(rname) == records.end()) {
    Record *r = new Record(rname, &frameworkServices, &measurement_m);
    //check to see if we are using MPI.  To do this, see if MPI_INIT has been   
    //called.  If it hasn't set rank to 0 for single cpu case.  Else, get   
    //a communicator and determine the cpu's rank.  
    int flag;
    MPI_Initialized(&flag);
    if(!flag){
      r->setRank(0);
    } else {

      int rank;
      MPI_Comm_rank(MPI_COMM_WORLD, &rank);
      r->setRank(rank);
      /*
      gov::cca::Port port;
      
      port = frameworkServices.getPort("MPIBorrow");
      if (port._not_nil()) {
	::ccaffeine::ports::MPIBorrow mpiPort = port;

	//get the communicator and set the rank 
	int key,tag,rank;


	::sidl::array< int32_t> tagList = ::sidl::array< int32_t>::create1d(10);
	

	MPI_Comm comm = mpiPort.borrowComm(1, tagList, key);
	MPI_Comm_rank(comm, &rank);
	r->setRank(rank);
      } else {
	std::cerr << "MPIBorrow port not connected!" << std::endl;
	r->setRank(0);
      }
      */
    }
    r->setFileName(rname);
    records[rname]=r;
  }//if

}







// DO-NOT-DELETE splicer.end(TauPerformance.MasterMind._misc)

